<?php
//
//  Copyright (c) 2022 NetApp, Inc.
//  All rights reserved.
//
// VERSION="1.0"
// NDU pre-check for "down" bgp peer-groups.

// When one or more BGP peer groups are down, it could result in going 
// offline during upgrade.

$foundPeerGroupsDown=0;
unset( $row );
unset($query);

// find lifs that can fail over to other nodes
// should be a mgmt lif
$query = "SELECT peer-group FROM bgp_peer_groups_ui where state<>up";
$result = dotsql_query($query);
while ($row = dotsql_fetch_object($result)) {
    $foundPeerGroupsDown = 1;
    break;
}

if ($foundPeerGroupsDown <> 0) {

    echo "<Alert>One or more BGP peer groups are down, which could result in lifs going offline during upgrade.</Alert>";
    echo "<Action>Identify the peer groups that are down using the command 'network bgp peer-group show -state down'. Take corrective action to ensure all peer groups are up.</Action>";
    echo "<Advice>Take corrective action to ensure all peer groups are up.</Advice>";
    echo "<RC>warning</RC>";
}

exit;
?>

