<?php
//
//  Copyright (c) 2014,2017,2020 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"
// NDU Compatibility for bridges

include 'mcc_util.php';



/**
 * Returns true if the bootarg is set to true, false otherwise.
 */
function isBootargTrue($val)
{
    return ((strcasecmp($val, "true") == 0) || ($val == "1"));
}

/**
 * Reads the kenv with the given name and returns its value.  If a kenv with
 * the given kenvNane does not exist, returns the empty string.
 */
function readKenv($kenvName)
{
    $value = "";

	//"$kenvName must be trusted to avoid risk of SQL injection."
    $result = dotsql_query("SELECT value FROM debug_kenv WHERE variable = $kenvName");
    if ($row = dotsql_fetch_object($result)) {
        $value = $row->value;
    }

    return $value;
}


$query = "SELECT model FROM bridge_profile_db WHERE model='FibreBridge6500N'";
$query_new = "SELECT model FROM bridge_profile_db WHERE model='FibreBridge 6500N'";
$result = dotsql_query($query);
$result_new = dotsql_query($query_new);

if (dotsql_num_rows($result) OR dotsql_num_rows($result_new) ) {
$bootargAtto = readKenv("bootarg.atto6500.supported");
	if (!isBootargTrue($bootargAtto)) {
    		echo "<Alert>The FibreBridge 6500N is not supported in the target ONTAP release.</Alert>";
    		echo "<Action>The bridges must be replaced with a supported model. To view the bridges in the cluster, run the command: system bridge show.</Action>";
    		echo "<Advice>Check for unsupported bridges in the cluster.</Advice>";
    		echo "<RC>error</RC>";
	}
}

exit;
?>
