<?php
//
//  Copyright (c) 2017 NetApp, Inc.
//  All rights reserved.
//
// VERSION="1.0"
// NDU Compatibility for CIFS

$query = "SELECT continuously-available FROM cifs_session WHERE continuously-available='Partial' LIMIT 1";
$result = dotsql_query($query);
$CAPartial = dotsql_num_rows($result);

$CANo = 0;

if (!$CAPartial) {
    $query = "SELECT continuously-available FROM cifs_session WHERE continuously-available='No' LIMIT 1";
    $result = dotsql_query($query);
    $CANo = dotsql_num_rows($result);
}

if (($CANo > 0) || ($CAPartial > 0)) {
    echo "<Alert>CIFS is currently in use.  Any unprotected sessions may be affected with possible loss of data.</Alert>";
    echo "<Action>Stop all unprotected CIFS workloads before performing the update.";
    echo "To list the unprotected CIFS workloads, run the command: vserver cifs session show -continuously-available No, Partial </Action>";
    echo "<Advice>Stop all unprotected CIFS workloads before performing the update.</Advice>";
    echo "<RC>warning</RC>";
    exit;
}

exit;
?>
