<?php
//
//  Copyright (c) 2016 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"

//
// Check if all the nodes are in CLAM quorum
//

// Initialize variables
$printed = false;

// Get quorum status from clam_node_status table
$query = "SELECT cluster-node FROM clam_master_view WHERE status-quorum != 'in-quorum'";
$result = dotsql_query($query);

while ($row = dotsql_fetch_object($result)) {
	$var = $row->{'cluster-node'};
	if ($printed != true) {
		echo "<Alert>Following nodes are out of CLAM quorum: $var";
		$printed = true;
	} else {
		echo ", $var";
	}
}

// Print Action and Advice if need be
if ($printed == true) {
	echo ".</Alert>";
	echo "<Action>Use KB article 2022109 (https://kb.netapp.com/support/index?page=content&id=2022109) to troubleshoot why the node(s) are not in CLAM quorum. Contact technical support for further assistance.</Action>";
	echo "<Advice>Use KB article 2022109 (https://kb.netapp.com/support/index?page=content&id=2022109) to troubleshoot why the node(s) are not in CLAM quorum. Contact technical support for further assistance.</Advice>";
	echo "<RC>error</RC>";
}

exit;
?>
