<?php

// Copyright (c) 2021-2022 NetApp, Inc.
// All rights reserved.

// If one or more cloud key managers are configured, print a message telling
// the user to make sure the cloud key managers are reachable.

// Are there any cloud key managers configured?
$ckms_configured = dotsql_query("SELECT keystore-type FROM keymanager_keystore_rdb WHERE 'keystore-type' != '' AND 'keystore-type' != 'KMIP' AND 'keystore-type' != 'OKM' LIMIT 1");
$warn_ckms_servers = dotsql_num_rows($ckms_configured);

$warning_alert = "To allow use of any cloud keymanager service after upgrade, cloud keymanager service availability must be verified.";
$warning_action = "Check that there are no unreachable cloud keymanager services using the (privilege: advanced) \"security key-manager external <aws|azure|gcp|ikp> check -category service_reachability -status !OK\" command. After running the appropriate command and validating the results, run the \"cluster image validate -version <package-version>\" command again.";
$warning_advice = "Check that all of the configured cloud keymanager services are available.";

if($warn_ckms_servers != 0){
     echo "<Alert>$warning_alert</Alert>";
     echo "<Action>$warning_action</Action>";
     echo "<Advice>$warning_advice </Advice>";
     echo "<RC>warning</RC>";
}

exit;

?>
