<?php
//
//  Copyright (c) 2014 NetApp, Inc.
//  All rights reserved.
//
// VERSION="1.0"
// NDU Compatibility for SCON VERIFY a cluster-mgmt lif exists

// a cluster mgmt lif is a management lif that can fail over
// to two or more nodes in the cluster
// it will be associated with any system vserver or the admin
// vserver

$foundClusMgmtLif=0;
unset( $row );
unset($query);

// find lifs that can fail over to other nodes
// should be a mgmt lif
$query = "SELECT lif FROM virtual_interface where vserver-type=admin|system and status-admin=up and failover-policy<>disabled and failover-policy<>local-only";
$result = dotsql_query($query);
while ($row = dotsql_fetch_object($result)) {
    $lif = $row->{'lif'};
    $foundClusMgmtLif = 1;
    break;
}

if( $foundClusMgmtLif == 0 ){

    $msg = "Management of the cluster during the upgrade may be disrupted because there are no management ";
    $msg .= "LIFs on this cluster that can fail over to another node. ";
    $msg .= "All existing management LIFs will become unavailable when their home node is rebooted during the upgrade process.";

    echo "<Alert>$msg</Alert>";
    echo "<Action>Create a cluster scoped management LIF with a \"service-policy\" of \"default-management\" and a \"failover-policy\" of \"broadcast-domain-wide\".</Action>";
    echo "<Advice>Modify the failover policy of a management lif from \"disabled\" or \"local-only\" to \"broadcast-domain-wide\"</Advice>";
    echo "<RC>warning</RC>";
}

exit;
?>

