<?php
//
// Copyright (c) 2023 NetApp, Inc.
// All rights reserved.
//

// VERSION="1.0"

//
// Check the logically over allocated volumes
//

$query = "SELECT volume FROM volume WHERE type=DP AND is-space-enforcement-logical=true AND space-guarantee=none AND logical-used-percent >= 100 LIMIT 1";
$result_vols = dotsql_query($query);
if (dotsql_num_rows($result_vols) != 0) {
   echo "<Alert>One or more DP volumes are logically over allocated. SnapMirror transfer operations may fail after upgrade.</Alert>";
   echo "<Action>Use the “volume show -logical-used-percent >= 100 -type DP -is-space-enforcement-logical true” command to list logically over allocated DP volumes. Either ensure these volumes are no longer logically over allocated by creating more free space or growing the volume size, or disable LSE on the SnapMirror source and destination volumes.</Action>";
   echo "<Advice>Ensure DP volumes are no longer logically over allocated by creating more free space or growing the volume size, or disable LSE on the SnapMirror source and destination volumes.</Advice>";
   echo "<RC>warning</RC>";
}

exit;
?>
