<?php
//
//  Copyright (c) 2022 NetApp, Inc.
//  All rights reserved.
//
// VERSION="1.0"
// NDU Compatibility for SCON VERIFY port e0M doesn't home a LIF with high
// speed services that were previously allowed by mistake.

$foundHighSpeedLif=0;
unset( $row );
unset($query);
unset($lifs);

// Find lifs with high speed services and a home-port of e0M.
$query = "SELECT lif FROM virtual_interface WHERE home-port=e0M AND services LIKE data-nvme-tcp|data-s3-server";
$result = dotsql_query($query);
while ($row = dotsql_fetch_object($result)) {
    $lifs .= $row->{'lif'} . " ";
    $foundHighSpeedLif = 1;
}

if( $foundHighSpeedLif != 0 ){

    echo "<Alert>LIFs \"$lifs\" with high speed data services might not be hosted because their \"home-port\", e0M, can't host LIFs with high speed services.</Alert>";
    echo "<Action>Change the \"home-port\" of all LIFs with high speed data services from e0M to a high speed port.</Action>";
    echo "<RC>warning</RC>";
}

exit;
?>


