<?php
//
// Copyright (c) 2020 NetApp, Inc.
// All rights reserved.
//
// This script will block ANDU if there are vservers with key migrate failures.
//

// VERSION="1.0"

$keystore_query = "SELECT vserver-id FROM keymanager_keystore_rdb WHERE state = mixed";
$keystore_result = dotsql_query($keystore_query);
if (dotsql_num_rows($keystore_result) > 0) {
    // Some vservers have key manager state == mixed. Let's find their names:
    $vserver_list = array();
    while ($keystore = dotsql_fetch_object($keystore_result)) {
        $vsid = $keystore->{'vserver-id'};
        $vserver_query = "SELECT vserver FROM vserver WHERE id = $vsid";
        $vserver_result = dotsql_query($vserver_query);
        if (dotsql_num_rows($vserver_result) > 0) {
            $vserver = dotsql_fetch_object($vserver_result);
            array_push($vserver_list, $vserver->{'vserver'});
        }
    }
    $vserver_list = implode(', ', $vserver_list);

    echo "<Alert>The following data Vservers with external key management enabled have encryption keys managed by the admin Vserver: $vserver_list.</Alert>";
    echo "<Action>For each data Vserver listed above, migrate the encryption keys from the admin Vserver to the data Vserver using the (privilege: advanced) 'security key-manager key migrate' command.</Action>";
    echo "<Advice>For each data Vserver listed above, migrate the encryption keys from the admin Vserver to the data Vserver.</Advice>";
    echo "<RC>error</RC>";
}

exit;

?>
