<?php
//
//  Copyright (c) 2017 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"

//
// Check if any IVs exist
//
$query = "SELECT volName FROM volumeKey WHERE type = infinitevol";
$result = dotsql_query($query);
if (dotsql_num_rows($result)) {
    echo "<Alert>Infinite Volumes and Vservers with Infinite Volumes were found on the cluster.</Alert>";
    echo "<Action>To show all Infinite Volumes, use the \"volume show -volume-style-extended infinitevol\" command. To delete the Infinite Volumes do the following for each Infinite Volume. First take if offline using the \"volume offline -vserver <vserver name> -volume <infinitevol name>\" command and then delete it using the \"volume delete -vserver <vserver name> -volume <infinitevol name>\" command. To show all Vservers with Infinite Volumes, use the \"vserver show -is-repository true\" command. To delete the Vservers with Infinite Volumes, first delete the Vserver root volume. To view the Vserver root volume, use the \"vserver show -vserver <vserver name> -fields rootvolume\" command. To delete the Vserver root volume, first take if offline using the \"volume offline -vserver <vserver name> -volume <root volume name>\" command and then delete it using the \"volume delete -vserver <vserver name> -volume <root volume name>\" command. Finally, to delete the Vserver with Infinite Volume, use the \"vserver delete -vserver <vserver name>\" command.</Action> ";
    echo "<Advice>Delete all Infinite Volumes and Vservers with Infinite Volumes from the cluster.</Advice>";
    echo "<RC>error</RC>";
}

//
// Check if any VSIVs exist
//
$query = "SELECT vserver FROM vserver WHERE is-repository = true";
$result = dotsql_query($query);
if (dotsql_num_rows($result)) {
    echo "<Alert>Vservers with Infinite Volumes were found on the cluster.</Alert>";
    echo "<Action>To show all Vservers with Infinite Volumes, use the \"vserver show -is-repository true\" command. To delete the Vservers with Infinite Volumes, first delete the Vserver root volume. To view the Vserver root volume, use the \"vserver show -vserver <vserver name> -fields rootvolume\" command. To delete the Vserver root volume, first take if offline using the \"volume offline -vserver <vserver name> -volume <root volume name>\" command and then delete it using the \"volume delete -vserver <vserver name> -volume <root volume name>\" command. Finally, to delete the Vserver with Infinite Volume, use the \"vserver delete -vserver <vserver name>\" command.</Action> ";
    echo "<Advice>Delete all Vservers with Infinite Volumes from the cluster.</Advice>";
    echo "<RC>error</RC>";
}

exit;
?>
