<?php

// Copyright (c) 2021 NetApp, Inc.
// All rights reserved.

// If one or more external key managers are configured, print a message telling
// the user to make sure there is a least one available key server.

// Are there any external key managers configured?
$external_keymanager_configured = dotsql_query("SELECT key-store FROM keymanager_keystore_rdb WHERE 'key-store' = external LIMIT 1");
$warn_key_servers = dotsql_num_rows($external_keymanager_configured);

$warning_alert = "To retrieve keys after upgrade, key server availability must be checked. If using clustered key servers, one or more key servers must be available, otherwise all key servers must be available.";
$warning_action = "If using clustered key servers, check that there is at least one key server available using the \"security key-manager external show-status -key-server-status available\" command. If not using clustered key servers, check that there are no unavailable key servers using the \"security key-manager external show-status -key-server-status !available\" command. After running the appropriate command and validating the results, run the \"cluster image validate -version <package-version>\" command again.";
$warning_advice = "Check that there is at least one key server available when using clustered key servers or no unavailable key servers when not using clustered key servers.";

if($warn_key_servers != 0){
     echo "<Alert>$warning_alert</Alert>";
     echo "<Action>$warning_action</Action>";
     echo "<Advice>$warning_advice </Advice>";
     echo "<RC>warning</RC>";
}

exit;




?>
