<?php
//
// Copyright (c) 2018 NetApp, Inc.
// All rights reserved.
//

// VERSION="1.0"

//
// Check to see that, if there are capacity licenses, all of
// them are in a state that will allow a rolling upgrade.
//

$capac_query = "SELECT node, state FROM license_v2_get_capacity";

$result = dotsql_query($capac_query);
$bad_states = 0;
$alert_msg = "Software instances on the following nodes cannot be updated until valid capacity licenses are installed on each:";


while ($row = dotsql_fetch_object($result)) {

   switch ($row->state) {
      case "enforce":
      case "eval-expired":
      case "eval-overage":
      case "eval-shut-down":
      case "revenue-enforce":
      case "revenue-shut-down":
      case "shut-down":
          $bad_states += 1;
          break;
      default:
          break;
   }

   switch ($bad_states) {
      case 0:
          break;
      case 1:
          echo "<Alert> $alert_msg \"$row->node\"";
          break;
      default:
          echo ", \"$row->node\"";
          break;
   }
}

// If this condition is true, then we have capacity licenses that
// require attention. If this variant of ONTAP does not support
// capacity licensing, we will never execute the inner block.

if ($bad_states > 0) {
   echo ".";
   $do_this = "Contact your sales representative for the appropriate capacity licenses, and install them prior to updating.";
   echo "</Alert> <Action>";
   echo $do_this;
   echo "</Action> <Advice>";
   echo $do_this;
   echo "</Advice>";
   echo "<RC>error</RC>";
}

exit;
?>
