<?php
//
//  Copyright (c) 2014-2017 NetApp, Inc.
//  All rights reserved.
//

// NDU Compatibility for metrocluster
    include 'mcc_util.php';

    $mccstate = getMCCConfigState();
    if ($mccstate == 'partially-configured' || $mccstate == 'configured') {
        $options = getoptreq('',array("major:", "downgrade::"));
        $majorupgrade = $options["major"];

        //$drcstate = getMCCOperationState();
        $localmode = getLocalMode();
        if ($localmode == 'switchover') {
	    // ANDU doesn't support
	    // (a) update of 2-node MetroCluster that is in SO state.
	    // (b) major update of 4/8-node MetroCluster that is in SO state.

	    $nodeCountQuery = "SELECT node FROM node";
	    $nodeCountQueryResult = dotsql_query($nodeCountQuery);
	    $nodeCount = dotsql_num_rows($nodeCountQueryResult);

	    if ($majorupgrade == "true" || $nodeCount == 1) {
		echo "<Alert>Automated NDU does not support major version upgrades of a MetroCluster configuration in switchover state.</Alert>";
		echo "<Action>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Action>";
		echo "<Advice>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Advice>";
		echo "<RC>error</RC>";
	    } else {
		echo "<Alert>MetroCluster is in switchover state.</Alert>";
		echo "<Action>The update can be done on this cluster. Ensure the DR site is also updated to same release when it is back in operation.</Action>";
		echo "<Advice>The update can be done on this cluster. Ensure the DR site is also updated to same release when it is back in operation.</Advice>";
		echo "<RC>warning</RC>";
	    }
        }
        elseif ($localmode != 'normal') {
            echo "<Alert>Automated NDU is not supported when MetroCluster is in the operational mode \"$localmode\".</Alert>";
	    echo "<Action>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Action>";
	    echo "<Advice>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Advice>";
	    echo "<RC>error</RC>";
        }
    }
    elseif ($mccstate != 'not-configured') {
        echo "<Alert>Automated NDU is not supported when MetroCluster is in the configuration state \"$mccstate\".</Alert>";
	echo "<Action>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Action>";
	echo "<Advice>Verify that MetroCluster is configured and in the operational mode \"normal\" before attempting NDU.</Advice>";
        echo "<RC>error</RC>";
    }
exit;
?>
