<?php

// Copyright (c) 2020 NetApp, Inc.
// All rights reserved.

// Check Metrocluster checks status.

$mcc_check_msg = "The MetroCluster check has reported some components to be in the warning state.";
$mcc_check_action = "Recover the components in the warning state and re-run the command \"metrocluster check run\" before starting ANDU. To check components in the warning state, run \"metrocluster check show\".";
$mcc_check_advice = "Recover the components in the warning state and re-run the MetroCluster check before starting ANDU.";

$mcc_aggr_check_msg = "The MetroCluster aggregate check has some warnings.";
$mcc_aggr_check_action = "Bring back the aggregates to mirrored state and re-run the command \"metrocluster check run \" before starting ANDU. To check not-mirrored aggregates, run \"metrocluster check aggregate show\". To recover run \"metrocluster check aggregate show -aggregate <aggregate name> -instance\" and follow recovery steps.";
$mcc_aggr_check_advice = "Bring back the aggregates to mirrored state and re-run the MetroCluster check before starting ANDU.";

$mcc_check_cluster_msg = "";
$mcc_check_cluster_action = "";
$mcc_check_cluster_advice = "";

$warning_alert = "";
$warning_action = "";
$warning_advice = "";

$error_alert = "";
$error_action = "";
$error_advice = "";

$is_warning = 0;
$is_error = 0;

$mcc_check_query = "SELECT result FROM metrocluster_check WHERE result != 'ok' OR result != 'not-applicable'";
$mcc_check_result = dotsql_query($mcc_check_query);

if (dotsql_num_rows($mcc_check_result) > 0){
     $warning_alert .= $mcc_check_msg;
     $warning_action .= $mcc_check_action;
     $warning_advice .= $mcc_check_advice;
     $is_warning++;
}

$mcc_check_cluster_query = "SELECT result,check FROM metrocluster_check_cluster WHERE (result != 'ok' OR result != 'not-applicable') AND (check = 'onboard-key-management' OR check = 'external-key-management')";
$mcc_check_cluster_result = dotsql_query($mcc_check_cluster_query);

while ($row = dotsql_fetch_object($mcc_check_cluster_result)) {
     $mcc_check_cluster_msg = "The MetroCluster check cluster has reported that the ".$row->check." component is in the warning state.";
     $mcc_check_cluster_action = "Recover the ".$row->check." component and re-run the command \"metrocluster check run\" before starting ANDU. To check the warning details, run \"metrocluster check cluster show -instance ".$row->check."\".";
     $mcc_check_cluster_advice = "Recover warning component ".$row->check." and re-run the MetroCluster check before starting ANDU.";
}
if (dotsql_num_rows($mcc_check_cluster_result) > 0){
     $error_alert .= $mcc_check_cluster_msg;
     $error_action .= $mcc_check_cluster_action;
     $error_advice .= $mcc_check_cluster_advice;
     $is_error++;
}

$mcc_aggr_check_query = "SELECT result FROM metrocluster_check_aggr WHERE result = 'warning' AND 'additional-info' LIKE '%is not mirrored%'";
$mcc_aggr_check_result = dotsql_query($mcc_aggr_check_query);

if (dotsql_num_rows($mcc_aggr_check_result) > 0){
     $warning_alert = $warning_alert." ".$mcc_aggr_check_msg;
     $warning_action = $warning_action." ".$mcc_aggr_check_action;
     $warning_advice = $warning_advice." ".$mcc_aggr_check_advice;
     $is_warning++;
}

if ($is_error > 0){
    echo "<Alert>$error_alert</Alert>";
    echo "<Action>$error_action</Action>";
    echo "<Advice>$error_advice</Advice>";
    echo "<RC>error</RC>";
} elseif ($is_warning > 0){
    echo "<Alert>$warning_alert</Alert>";
    echo "<Action>$warning_action</Action>";
    echo "<Advice>$warning_advice</Advice>";
    echo "<RC>warning</RC>";
}
exit;

?>
