<?php

// Copyright (c) 2020 NetApp, Inc.
// All rights reserved.


// VERSION="1.0"


//Check for invalid MCC configs, Vserver config state, cluster peering state.




$alert_health = "SVM configuration is not in sync between source and destination cluster.";
$action_health = "Check SVM configuration state. To check status, run \"metrocluster vserver show\"";
$advice_health = "Check SVM configuration state";

$warning_alert = "";
$warning_action = "";
$warning_advice = "";

$alert_config = "Metrocluster is not configured properly.";
$action_config = "Check metrocluster configuration. To check status, run \"metrocluster show\"";
$advice_config = "Check metrocluster configuration";


$is_warning = 0;
$vserver_health_query = "SELECT configuration-state FROM source_vservers_byname WHERE configuration-state != 'healthy' OR configuration-state != 'pending-switchback'";
$vserver_health_result = dotsql_query($vserver_health_query);
$vserver_health_rows = dotsql_num_rows($vserver_health_result);
if($vserver_health_rows > 0)
{
	$warning_alert = $alert_health;
	$warning_action = $action_health;
	$warning_advice = $advice_health;
	$is_warning++;
}

$mcc_config_query = "SELECT configuration-type FROM metrocluster WHERE configuration-type = 'invalid'";
$mcc_config_result = dotsql_query($mcc_config_query);
if(dotsql_num_rows($mcc_config_result) >0)
{
	$warning_alert = $warning_alert." ".$alert_config;
	$warning_action = $warning_action." ".$action_config;
	$warning_advice = $warning_advice." ".$advice_config;
	$is_warning++;
}



if($is_warning >0){
	echo "<Alert>$warning_alert</Alert>";
	echo "<Action>$warning_action</Action>";
	echo "<Advice>$warning_advice</Advice>";
        echo "<RC>error</RC>";
}

exit;
?>
