<?php
//
//  Copyright (c) 2019 NetApp, Inc.
//  All rights reserved.
//
// Check for minimum number of disks in aggregates
// sfo aggregates with raid type as raid_dp should have a minimum of 5 disks.
// sfo aggregates with raid type as raid4 should have a minimum of 3 disks.

$raiddp_error = false;
$raid4_error = false;

$alert_raiddp = "";
$action_raiddp = "";
$advice_raiddp = "";

$alert_raid4 = "";
$action_raid4 = "";
$advice_raid4 = "";

$queryaggr = "SELECT diskcount, raidtype FROM aggr WHERE ha-policy = 'sfo' AND raidtype = 'raid_dp' AND diskcount < 5 limit 1";
$resultaggr = dotsql_query($queryaggr);

while ($rowaggr = dotsql_fetch_object($resultaggr)) {
	$raiddp_error = true;
	$alert_raiddp = "It is recommended to have a minimum of 5 disks in a data aggregate with RAID Double Parity. ";
	$action_raiddp = "To check for the number of disks in a data aggregate with RAID Double Parity, run the \"storage aggregate show -raidtype raid_dp -ha-policy sfo -diskcount < 5 -fields diskcount\" command. To add disks to the aggregate, run the \"storage aggregate add-disks -aggregate <aggr name> -diskcount <number of disks>\". ";
	$advice_raiddp = "It is recommended to have a minimum of 5 disks in a data aggregate with RAID Double Parity. ";
	break;
}

$queryaggr = "SELECT diskcount, raidtype FROM aggr WHERE ha-policy = 'sfo' AND raidtype = 'raid4' AND diskcount < 3 limit 1";
$resultaggr = dotsql_query($queryaggr);

while ($rowaggr = dotsql_fetch_object($resultaggr)) {
	$raid4_error = true;
	$alert_raid4 = "It is recommended to have a minimum of 3 disks in a data aggregate with RAID type RAID4. ";
	$action_raid4 = "To check for the number of disks in a data aggregate with RAID type RAID4, run the \"storage aggregate show -raidtype raid4 -ha-policy sfo -diskcount < 3 -fields diskcount.\" command. To add disks to the aggregate, run the \"storage aggregate add-disks -aggregate <aggr name> -diskcount <number of disks>\". ";
	$advice_raid4 = "It is recommended to have a minimum of 3 disks in a data aggregate with RAID type RAID4. ";
	break;
}

if ($raiddp_error || $raid4_error) {
	echo "<Alert>".$alert_raiddp." ".$alert_raid4."</Alert>";
	echo "<Action>".$action_raiddp." ".$action_raid4."</Action>";
	echo "<Advice>".$advice_raiddp." ".$advice_raid4."</Advice>";
	echo "<RC>warning</RC>";
}

exit;
?>
