<?php
//
//  Copyright (c) 2019 NetApp, Inc.
//  All rights reserved.
//
// Check whether non-root aggregates have sfo ha-policy. Data aggregates should not have cfo HA-policy. During a fail over situation,
// the partner node would not be able to assume control of this aggregate to serve data and access to this aggregate would be lost.
//

$alert = "";
$action = "";
$advice = "";
$ron_root_cfo = false;

$queryaggr = "SELECT aggregate, root FROM aggr WHERE ha-policy = cfo and root = false limit 1";
$resultaggr = dotsql_query($queryaggr);

if ($rowaggr = dotsql_fetch_object($resultaggr)) {
		$non_root_cfo = true;
		$alert = "Non-root aggregates should always have \"SFO\" as the HA-policy.";
		$action = "To list the HA policy of non-root aggregates, use the \"storage aggregate show -root false -fields ha-policy\" command.";
		$advice = "Non-root aggregates should not have their HA policy be \"CFO\".  With a \"CFO\" policy, failover could lead to data loss.";
}

if ($non_root_cfo) {
	echo "<Alert>".$alert."</Alert>";
	echo "<Action>".$action."</Action>";
	echo "<Advice>".$advice."</Advice>";
	echo "<RC>warning</RC>";
}

exit;
?>

