<?php
//
// Copyright (c) 2019 NetApp, Inc.
// All rights reserved.
//

// VERSION="1.0"


//Check for enviornment components failure


$alert_shelf = "All of the shelves are not in normal condition.";
$action_shelf = "Ensure all shelves are in normal condition. To check status, run \"storage shelf show\".";
$advice_shelf = "Ensure all shelves are in normal condition.";

$alert_sensor = "All of the sensors are not in normal condition.";
$action_sensor = "Ensure all sensors are in normal condition. To check status, run \"system node run * environment status\"";
$advice_sensor = "Ensure all sensors are in normal condition.";

$error_alert = "";
$error_action = "";
$error_advice = "";

// Display message only for real hardware models i.e., FAS or AFF systems
$board_type_query= dotsql_query("SELECT board-type FROM system_node_info WHERE board-type != 'NetApp VSim' OR board-type != 'Virtual Machine'");

$is_warning = 0;
if(dotsql_num_rows($board_type_query)>0) {
    $shelf_query = dotsql_query("SELECT op-status from storage_shelf_view where op-status != 'Normal' LIMIT 1");
    if(dotsql_num_rows($shelf_query)> 0) {
        $error_alert = $alert_shelf;
        $error_action = $action_shelf;
        $error_advice = $advice_shelf;
        $is_warning++;
    }
    $sensor_query = dotsql_query("SELECT state from environment_sensors where state != normal LIMIT 1");
    if(dotsql_num_rows($sensor_query)> 0) {
        $error_alert = $error_alert." ".$alert_sensor;
        $error_action = $error_action." ".$action_sensor;
        $error_advice = $error_advice." ".$advice_sensor;
        $is_warning++;
    }
    if($is_warning >0) {
         echo "<Alert>$error_alert</Alert>";
         echo "<Action>$error_action</Action>";
         echo "<Advice>$error_advice</Advice>";
         echo "<RC>warning</RC>";
    }
}


exit;
?>
