<?php
//
//  Copyright (c) 2018 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"
// NDU Compatibility for snapmirror sync
//
// If there are snapmirror sync relationships, either source or destination,
// return a warning as the relationship call fall out of sync

function checkSyncRelations() {
    $result = dotsql_query("SELECT policyType FROM localDstSnapMirror WHERE policyType = strict-sync-mirror|sync-mirror LIMIT 1");
    if (dotsql_num_rows($result) > 0) {
	return true;
    }

    $result = dotsql_query("SELECT policyType FROM localSrcSnapMirror WHERE policyType = strict-sync-mirror|sync-mirror LIMIT 1");
    if (dotsql_num_rows($result) > 0) {
	return true;
    }

    return false;
}

# Check for Sync relationships
if (checkSyncRelations() == false)
{
    // no warnings; it's all good
    exit;
}

// frame the action/advice message:
$alert = "The cluster hosts volumes that are in a SnapMirror Synchronous" .
    " relationship. During the upgrade process, the relationships will" .
    " go out of sync. Volumes which are in a SnapMirror Synchronous" .
    " Strict Sync relationship will be unavailable for client I/O.";

// For now advice and alert are the same, so that the message is displayed
// properly in the CLI and also show in the UI
$advice = $alert;

$action = "Run 'snapmirror show' or 'snapmirror list-destinations' to" .
    " identify volumes that are in SnapMirror Synchronous relationship.";

// dump out the messages
echo "<Alert>" . $alert . "</Alert>";
echo "<Advice>" . $advice . "</Advice>";
echo "<Action>" . $action . "</Action>";
echo "<RC>warning</RC>";
exit;
?>
