<?php
//
//  Copyright (c) 2014 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"

//
// Check if volumes are offline
//
include 'mcc_util.php';
global $mccconfigured;
define("mccconfigured","false");
global $mccswitchedover;
$offlinevolfound = false;
$inconsistentvolfound = false;


$options = getoptreq('',array("major:", "downgrade::"));
$majorupgrade = $options["major"];

if(!isValidMCCState()) {
    exit;
}

// DOTSQL does not support OR operation along with AND.
// Hence, have to run query twice - once for inconsistent check and
// again for offline check.
//echo "Check for inconsistent volumes...\n";
$query = "SELECT volume FROM volume WHERE is-inconsistent = true AND type != DEL LIMIT 1";
$result = dotsql_query($query);
if (dotsql_num_rows($result)) {
    //echo "There are some inconsistent volumes...";
    $inconsistentvolfound = true;
}

if ($majorupgrade == "true") {
    $query = "SELECT vserver,aggregate FROM volume WHERE state != online AND state != restricted AND type != DEL AND node != '' LIMIT 1";
    $result = dotsql_query($query);

    //echo "We check for offline volumes only for major upgrades...";
    if ($mccconfigured) {
	while ($row = dotsql_fetch_object($result)) {
	    //echo "Some offline volumes exist...";
	    $vserver = $row->vserver;
	    $query = "SELECT type,subtype FROM vserver WHERE vserver = $vserver";
	    $resultvs = dotsql_query($query);
	    //echo "Vserver query for $vserver is done...";
	    if ($rowvs = dotsql_fetch_object($resultvs)) {
		//echo "Got vserver properties from vserver table...";
		if($rowvs->type == 'admin') {
		    //echo "vserver is a CSERVER. Finding if volume is from remote cluster...";
		    $aggregate = $row->aggregate;
		    $query = "SELECT cluster-id FROM aggr WHERE aggregate = $aggregate";
		    $resultag = dotsql_query($query);
		    if($rowag = dotsql_fetch_object($resultag)) {
			//echo "Got the aggregate properties from aggr table...";
			$clusterid = $rowag->{'cluster-id'};
			$query = "SELECT uuid from cluster_id";
			$resultcid = dotsql_query($query);
			if($rowcid = dotsql_fetch_object($resultcid)) {
			    if($rowcid->uuid != $clusterid) {
				//echo "cluster-id of aggr is not local, contuining...";
				continue;
			    }
			}
		    }
		    $offlinevolfound = true;
		    break;
		}
		if($rowvs->subtype != 'sync-destination') {
		    //echo "Vserver type is NOT sync-destination, offline vol found...";
		    $offlinevolfound = true;
		    break;
		} elseif ($mccswitchedover) {
		    //echo "Vserver type is sync-destination, but in switchedover state. Offline vol found...";
		    $offlinevolfound = true;
		    break;
		}
	    }
	}
    } elseif (dotsql_num_rows($result)) {
	//echo "Not an MCC configuration and there are some offline volumes...";
	$offlinevolfound = true;
    }
}


if ($inconsistentvolfound && $offlinevolfound) {
    echo "<Alert>Volumes were found inconsistent and offline that must be fixed and changed to online before attempting upgrade.</Alert> <Action>To check for inconsistent volumes, run the command: volume show -is-inconsistent true. To check for volumes that need to be brought online, run the command: volume show -state !online -state !restricted</Action> ";
    echo "<Advice>Check for inconsistent and offline volumes in the cluster.</Advice>";
    echo "<RC>error</RC>";
    exit;
}

if ($offlinevolfound) {
    echo "<Alert>Volumes were found that must be changed to online state before attempting NDU.</Alert> <Action>To check for volumes that need to be brought online, run the command: volume show -state !online -state !restricted</Action> ";
    echo "<Advice>Check for offline volumes in the cluster.</Advice>";
    echo "<RC>error</RC>";
    exit;
}

if ($inconsistentvolfound) {
    echo "<Alert>Volumes were found inconsistent that must be fixed before attempting upgrade.</Alert> <Action>To check for inconsistent volumes, run the command: volume show -is-inconsistent true</Action> ";
    echo "<Advice>Check for inconsistent volumes in the cluster.</Advice>";
    echo "<RC>error</RC>";
}

exit;
?>
