<?php
//
//  Copyright (c) 2017 NetApp, Inc.
//  All rights reserved.
//

// NDU Compatibility for metrocluster
// This script checks whether the vservers in a two node metrocluster setup are
// in degraded state or not before attempting validation on the image.

     // Get vserver configuration-state from metrocluster_vserver_ui table
    $query = "SELECT vserver FROM metrocluster_vserver_ui WHERE configuration-state = degraded";
    $result = dotsql_query($query);
    $vserver_list = array();

    //Check if any of the vservers are not in healthy state
    if (dotsql_num_rows($result)) {

        while($row = dotsql_fetch_object($result)) {
            array_push($vserver_list, $row->{'vserver'});
        }

        $vserver_list = implode(', ', $vserver_list);

        echo "<Alert>The following Vservers are in degraded state and update cannot be started on the MetroCluster: \"$vserver_list\"</Alert>";
        echo "<Action>Resynchronize the configuration using the \"metrocluster vserver resync\" command. If the configuration-state does not change to healthy, contact technical support for assistance.</Action>";
        echo "<Advice>Resynchronize the Vserver configuration and retry the operation.</Advice>";
        echo "<RC>error</RC>";
    }
exit;
?>
