<?php
//
//  Copyright (c) 2022 NetApp, Inc.
//  All rights reserved.
//

// VERSION="1.0"
// ONTAP API to REST Transition Warning

$query = "SELECT interface FROM session_node_application_stats WHERE interface = 'ontapi' AND idle-seconds <= '2592000'";

$result = dotsql_query($query);

if (dotsql_num_rows($result) > 0) {
	echo "<Alert>NetApp ONTAP API has been used on this cluster for ONTAP data storage management within the last 30 days.";
	echo "\nNetApp ONTAP API is approaching end of availability.</Alert>";

	echo "<Action>Transition your automation tools from ONTAP API to ONTAP REST API.";
	echo "\nFor more details, refer to CPC-00410 - End of availability: ONTAPI";
	echo "\nhttps://mysupport.netapp.com/info/communications/ECMLP2880232.html</Action>";

	echo "<Advice>Transition your automation tools from ONTAP API to ONTAP REST API.";
	echo "\nCPC-00410 - End of availability: ONTAPI : https://mysupport.netapp.com/info/communications/ECMLP2880232.html</Advice>";

	echo "<RC>warning</RC>";
}

exit;
?>
